/*
 * Assembly Language Debugger
 *
 * Copyright (C) 2000 Patrick Alken
 * This program comes with absolutely NO WARRANTY
 *
 * Should you choose to use and/or modify this source code, please
 * do so under the terms of the GNU General Public License under which
 * this program is distributed.
 *
 * $Id: terminal.h,v 1.3 2001/04/07 01:00:00 cosine Exp $
 */

#ifndef INCLUDED_terminal_h
#define INCLUDED_terminal_h

#ifndef INCLUDED_defs_h
#include "defs.h"        /* HAVE_TERMIOS_H */
#define INCLUDED_defs_h
#endif

#if defined(HAVE_TERMIOS_H)
#include <termios.h>
#elif defined(HAVE_TERMIO_H)
#include <termio.h>
#endif

/*
 * Prototypes
 */
void InitTerm();
void SaveParentTerminalState();
void RestoreParentTerminalState();
void SaveChildTerminalState();
void RestoreChildTerminalState();

/*
 * External declarations
 */
extern int              LinesPerPage;
extern int              ColsPerLine;

#endif /* INCLUDED_terminal_h */
